#!/bin/bash
INPUT=/var/spool/qshdlg/input
OUTPUT=/var/spool/qshdlg/output
CONTROL=/var/spool/qshdlg/control

tardlist() {
tar tvf "$1" | sed -e 's/^[^[:blank:]]*[[:blank:]]*[^[:blank:]]*//' -e 's/[[:blank:]]*[^\/0-9a-z]*//'
}

tgzdlist() {
gzip -dc "$1" | tar tvf - | sed -e 's/^[^[:blank:]]*[[:blank:]]*[^[:blank:]]*//' -e 's/^[[:blank:]]*\/[0-9a-z]*//'
}

zipdlist() {
unzip -l "$1" | sed -n -e '/^ --------.*/b' -e '/^.*files$/b' -e '3~1p' | cut -b "2-10,12-25,28-"
}
lhadlist() {
lha vvg "$1" | sed -n -e '3~2h' -e '$b' -e '4~2{' -e 'G' -e 's/\[2\]\n//' -e 'p' -e '}' | cut -b "31-39,58-76,77-"
}

readresult() {
	IFS=$'\n'
	while read "ret" ;do
		echo 'item(QString) "'  "$ret" '"' >$CONTROL
	done
}

echo 書庫部分解凍/削除
echo 
if [ $# -gt 2 ]; then
	echo "複数のファイルは指定できません"
	exit 127
fi
if [ -f "$2" ];then
	dest=${2%/*}
else
	dest="$2"
fi
if [ -z $(which perl) ];then
	perlf=1
else
	perlf=0
fi
if [ -z $(which sudo) ];then
	suf=""
elif [ "$(isfat "$dest")" = "FAT" ];then
	suf="sudo"
else
	suf=""
fi

qshdlg custom -c utf8 -t "書庫部分解凍 -> $2" -C "select" -n -m -N 2>/dev/null & 
echo 'cancel(QString) Quit' >$CONTROL
ext=${1##*.}
ext=$(echo "$ext" | tr 'A-Z' 'a-z')
case $ext in
	lzh) lhadlist "$1" | readresult ;;
	zip) zipdlist "$1" | readresult ;;
	tar) tardlist "$1" | readresult ;;
	gz)  tgzdlist "$1" | readresult ;;
esac
echo 'showMulti()' >$CONTROL
si="xxx"
i=0
while read si  da  ti  "fname" <$INPUT ; do
	if [ -z $si ];then
		break;
	fi
	if [ $si = "Quit" ];then
		echo 'reject()' >$CONTROL
		echo "中断しました"
		exit 1
	fi
	files[$i]="$fname"
	flist[$i]="$si $da $ti $fname"
	i=$(( $i + 1 ))
done
echo 'hideSelect()' >$CONTROL

echo 'showMessage()' >$CONTROL
echo "操作を選択してください"　>$OUTPUT
if [ perlf ] ;then
	echo 'item(QString,QString)' "上書解凍 O" >$CONTROL
	echo 'item(QString,QString)' "更新解凍 U" >$CONTROL
	echo 'item(QString,QString)' "追加解凍 P" >$CONTROL
else
	echo 'item(QString,QString)' "解凍 U" >$CONTROL
fi
if [ $ext = "lzh" ] || [ $ext = "zip" ] ; then
	echo 'item(QString,QString)' "削除 D" >$CONTROL
fi
echo 'item(QString,QString)' "中止 A" >$CONTROL
echo 'showReply()' >$CONTROL
read act <$INPUT
if [ $act = "A" ] || [ $act = "Quit" ] ;then
	echo 'reject()' >$CONTROL
	echo "中断しました"
	exit 1
fi

if [ $act = "D" ] ; then
	echo 'reject()' >$CONTROL
	case $ext in
		lzh) $suf lha dgfq1 "$1" "${files[@]}" ;;
		zip) $suf zip -d "$1" "${files[@]}" ;;
	esac
else 
	if [ $ext != "zip" ] || [ $act != "O" ];then
		echo 'reject()' >$CONTROL
	else 
		echo 'hideReply()' >$CONTROL
		echo 'showInput()' >$CONTROL
	fi

	if [ perlf ] && [ $act != "O" ];then
		if [ $act = "U" ];then
			act="-u"
		else
			act="-a"
		fi
		if [ -z $suf ];then
			suf="no"
		fi
		export PERL_BADLANG=0
		${0%/*}/fl_filecmp.pl $suf $ext "$act" "$1" "$dest" "${flist[@]}"
		exit $?
	fi
	case $ext in
		lzh) $suf lha egfq1w="$dest" "$1" "${files[@]}" ;;
		zip) $suf unzip -d "$dest" "$1" "${files[@]}" <$INPUT 2>$OUTPUT ;;
		tar) $suf tar xvf "$1" -C "$dest" "${files[@]}" ;;
		gz)  gzip -dc "$1" | $suf tar xvf - -C "$dest" "${files[@]}" ;;
	esac
	if [ $ext = "zip" ];then
		echo 'reject()' >$CONTROL
	fi
fi
