#!/bin/bash

INPIPE=/var/spool/qshdlg/input
OUTPIPE=/var/spool/qshdlg/output
CTLPIPE=/var/spool/qshdlg/control

greps() {
	for i in $* ; do
		if [ -z $(echo $i | grep "/$" )  ]; then
			dest=$i/*
		else
			dest=$i*
		fi
		grep -le "$target"  $dest 2>/dev/null
	done
}


if [ $# -gt 2 ]; then
	echo "複数のファイルは指定できません"
	exit 127
fi
if [ -z $(which sudo) ];then
	suf=""
else
	suf="sudo "
fi
if [ "$1" = "" ];then
	dir="/"
elif [ ! -d "$1" ] ;then
	dir=${1%/*}
	dir="$dir/"
else
	dir="$1/"
fi
qshdlg custom -c utf8 -t "拡張ファイル検索" -C "message" -n -N 2>/dev/null & 
echo 'direction(QString,QString)' Button TopToBottom >$CTLPIPE
echo 'scrollAuto(int)' 1 >$CTLPIPE
echo 'cancel(QString)' "Quit" >$CTLPIPE
echo "検索する対象の種類を選択してください" >$OUTPIPE
echo 'item(QString,QString)' "特定文字列を含むファイル" "G" >$CTLPIPE
echo 'item(QString,QString)' "特定条件に適合するファイル" "F" >$CTLPIPE
echo 'showReply()' >$CTLPIPE
read "findtype" <$INPIPE
echo 'hideReply()' >$CTLPIPE

if [ $findtype = "Quit" ]; then
	echo 'reject()' >$CTLPIPE
	echo "中断しました"
	exit 0
fi
if [ $findtype = "G" ]; then
	if [ -z $(which nkf) ];then
		echo "nkf をインストールしてください"
		exit 127
	fi
	echo "文字列の文字コードを選択してください" >$OUTPIPE
	echo 'item(QString,QString)' "EUC-JP" "e" >$CTLPIPE
	echo 'item(QString,QString)' "SHIFT-JIS" "s" >$CTLPIPE
	echo 'item(QString,QString)' "UTF-8" "w" >$CTLPIPE
	echo 'item(QString,QString)' "JIS" "j" >$CTLPIPE
	echo 'showReply()' >$CTLPIPE
	read "codec" <$INPIPE
	echo 'hideReply()' >$CTLPIPE
	if [ $codec = "Quit" ]; then
		echo 'reject()' >$CTLPIPE
		echo "中断しました"
		exit 0
	fi
	case $codec in
	"e") codename="EUC-JP" ;;
	"s") codename="SHIFT-JIS" ;;
	"w") codename="UTF-8" ;;
	"j") codename="JIS" ;;
	esac
	echo "検索対象文字列を入力してください" >$OUTPIPE
	echo "（ 正規表現が利用できます）" >$OUTPIPE
	echo "（TABキー2回で入力欄にフォーカスが移動します）" >$OUTPIPE
	echo 'showInput()' >$CTLPIPE
	read "str" <$INPIPE
	echo 'hideInput()' >$CTLPIPE

	echo 'reject()' >$CTLPIPE
	echo "文字列「$str」( $codename )で検索中です...."
	nopt="-W$codec"
	if [ $codec != "w" ]; then
		target=$(echo "$str" | nkf $nopt)
	else
		target="$str"
	fi
	files=$(${suf}find "$dir" -type d)
	IFS=$'\n'
	lists=$( greps $files )
	qcop3 QPE/Application/filelaunch 'setFileSelection(QString,QString,QStringList)' "文字列「$str」を含むファイル" $dir $lists 2>/dev/null &
	exit 0
fi

echo "ファイル名で検索しますか？" >$OUTPIPE
echo 'item(QString,QString)' "はい" "Y" >$CTLPIPE
echo 'item(QString,QString)' "いいえ" "N" >$CTLPIPE
echo 'showReply()' >$CTLPIPE
read "usefile" <$INPIPE
echo 'hideReply()' >$CTLPIPE
if [ $usefile = "Quit" ]; then
	echo 'reject()' >$CTLPIPE
	echo "中断しました"
	exit 0
fi

if [ $usefile = "Y" ]; then
	echo "検索するファイル名を入力してください" >$OUTPIPE
	echo "（*a*.txtなどのワイルドカードが使えます）" >$OUTPIPE
	echo "（TABキー2回で入力欄にフォーカスが移動します）" >$OUTPIPE

	echo 'showInput()' >$CTLPIPE
	read "findtarget" <$INPIPE
	echo 'hideInput()' >$CTLPIPE
	if [ -z "$findtarget" ] ; then
		usefile="N"
	fi
	if [ $usefile = "Y" ]; then
		echo "  ファイル名 : $findtarget" >$OUTPIPE
	fi
fi

echo "検索するファイルの種類を指定してください" >$OUTPIPE
echo 'item(QString,QString)' "すべて対象" "No" >$CTLPIPE
echo 'item(QString,QString)' "ディレクトリ" "d" >$CTLPIPE
echo 'item(QString,QString)' "シンボリックリンク" "l" >$CTLPIPE
echo 'item(QString,QString)' "通常ファイル" "f" >$CTLPIPE
echo 'showReply()' >$CTLPIPE
read "filetype" <$INPIPE
echo 'hideReply()' >$CTLPIPE
if [ $filetype = "Quit" ]; then
	echo 'reject()' >$CTLPIPE
	echo "中断しました"
	exit 0
fi

case $filetype in
f) typename="ファイル "    ;;
d) typename="ﾃﾞｨﾚｸﾄﾘ "    ;;
l) typename="ｼﾝﾎﾞﾘｯｸﾘﾝｸ "   ;;
*) typename="すべてのファイル"  ;;
esac

echo "  $typename を検索します" >$OUTPIPE

echo "検索するファイルの範囲を選択してください" >$OUTPIPE
echo 'item(QString,QString)' "x日前以降" "A" >$CTLPIPE
echo 'item(QString,QString)' "x日前以前" "B" >$CTLPIPE
echo 'item(QString,QString)' "x日前丁度" "J" >$CTLPIPE
echo 'item(QString,QString)' "指定しない" "C" >$CTLPIPE
echo 'showReply()' >$CTLPIPE
read "mtime" <$INPIPE
echo 'hideReply()' >$CTLPIPE
if [ $mtime = "Quit" ]; then
	echo 'reject()' >$CTLPIPE
	echo "中断しました"
	exit 0
fi

if [ $mtime != "C" ];then
	echo "日数を入力してください" >$OUTPIPE
	echo "（数字だけを入力してください）" >$OUTPIPE
	echo "（TABキー2回で入力欄にフォーカスが移動します）" >$OUTPIPE
	tcnt="x"
	while [ ! -z $( echo $tcnt | sed -e s/[0-9]//g ) ]; do
		echo 'showInput()' >$CTLPIPE
		read "tcnt" <$INPIPE
		echo 'hideInput()' >$CTLPIPE
		if [ $tcnt = "Quit" ]; then
			echo 'reject()' >$CTLPIPE
			echo "中断しました"
			exit 0
		fi
	done
fi

echo 'reject()' >$CTLPIPE
case $mtime in
A) tc=+$tcnt ;;
B) tc=-$tcnt ;;
J) tc=$tcnt ;;
*) tc=$tcnt ;;
esac

echo "検索中です...."
if [ $usefile = "Y" ]; then
	if [ $filetype != "No" ]; then
		if [ $mtime != "C" ]; then
			files=$(${suf}find "$dir" -name "$findtarget" -type $filetype -mtime $tc )
		else 
			files=$(${suf}find "$dir" -name "$findtarget" -type $filetype )
		fi
	else
		if [ $mtime != "C" ]; then
			files=$(${suf}find "$dir" -name "$findtarget" -mtime $tc )
		else 
			files=$(${suf}find "$dir" -name "$findtarget" )
		fi
	fi
else
	if [ $filetype != "No" ]; then
		if [ $mtime != "C" ]; then
			files=$(${suf}find "$dir" -type $filetype -mtime $tc )
		else 
			files=$(${suf}find "$dir" -type $filetype )
		fi
	else
		if [ $mtime != "C" ]; then
			files=$(${suf}find "$dir" -mtime $tc )
		fi
	fi
fi

if [ $usefile = "Y" ];then
	fexp="ファイル名 : $findtarget "
fi
case $filetype in
f) fexp="$fexp 種類：ファイル "    ;;
d) fexp="$fexp 種類：ﾃﾞｨﾚｸﾄﾘ "    ;;
l) fexp="$fexp 種類：ｼﾝﾎﾞﾘｯｸﾘﾝｸ "   ;;
*) fexp="$fexp"   ;;
esac

case $mtime in
A) fexp="$fexp $tcnt日前以降に更新"  ;;
B) fexp="$fexp $tcnt日前以前に更新"  ;;
J) fexp="$fexp $tcnt日前に更新"  ;;
*) fexp="$fexp"  ;;
esac

IFS=$'\n'
if [ -z "${files}" ]; then
	echo "検索対象に該当するファイルはありません"
	exit 1
fi
qcop3 QPE/Application/filelaunch 'setFileSelection(QString,QString,QStringList)' "$fexp" "$dir" ${files} 2>/dev/null &
