#!/bin/bash


tarlist() {
tar tvf "$1" | sed -e 's/^[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*//' -e 's/^[0-9][0-9]:[0-9][0-9]:[0-9][0-9][[:blank:]]//'
}
tgzlist() {
gzip -dc "$1" 2>/dev/null| tar tvf - | sed -e 's/^[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*//' -e 's/^[0-9][0-9]:[0-9][0-9]:[0-9][0-9][[:blank:]]//'
}

ipklist() {
gzip -dc "$1" 2>/dev/null| tar xvOf - ./control.tar.gz | gzip -dc 2>/dev/null| tar tvf - | sed -e 's/^[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*//' -e 's/^[0-9][0-9]:[0-9][0-9]:[0-9][0-9][[:blank:]]//'
gzip -dc "$1" 2>/dev/null| tar xvOf - ./data.tar.gz | gzip -dc 2>/dev/null| tar tvf - | sed -e 's/^[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*[^[:blank:]]*[[:blank:]]*//' -e 's/^[0-9][0-9]:[0-9][0-9]:[0-9][0-9][[:blank:]]//'
}
ziplist() {
if [ -z $(which unzip) ] ;then
	echo "Zip Files"
else
	unzip -l "$1" | sed -n -e '/^ --------.*/b' -e '/^.*files$/b' -e '3~1p' | cut -b 29-
fi
}
lhalist(){
if [ -z $(which lha) ] ;then
	echo "lzh Files"
else
	lha lg "$1" | sed -n -e '/^----------.*/b' -e '/^ Total.*/b' -e '3~1p'| cut -b 52-
fi
}

tardlist() {
tar tvf "$1" | cut -b "23-31,34-47,51-"
}

tgzdlist() {
gzip -dc "$1" 2>/dev/null| tar tvf - | cut -b "23-31,34-47,51-"
}
zipdlist() {
unzip -l "$1" | sed -n -e '/^ --------.*/b' -e '/^.*files$/b' -e '3~1p' | cut -b "2-10,12-25,28-"
}
lhadlist() {
lha vvg "$1" | sed -n -e '3~2h' -e '$b' -e '4~2{' -e 'G' -e 's/\[2\]\n//' -e 'p' -e '}' | cut -b "31-39,60-73,77-"
}

ext=${1##*.}
ext=$(echo "$ext" | tr 'A-Z' 'a-z')
case $ext in
lzh) lhalist "$1" ;;
zip) ziplist "$1" ;;
tar) tarlist "$1" ;;
gz)  tgzlist "$1" ;;
ipk) ipklist "$1" ;;
exe) lhalist "$1" ;;
esac
